#include <iostream>
#include <iomanip>
#include <cmath>

#ifndef M_PI_4
#define M_PI_4 0.785398163397448309616
#endif

int main() {
    int x0, y0, x1, y1, x2, y2, x3, y3;
    std::cin >> x0 >> y0 >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    std::cout << std::fixed << std::setprecision(30) << ((x1 - x0) * (y3 - y0) - (y1 - y0) * (x3 - x0)) * M_PI_4 << std::endl;
}
